Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLab.MainForm.Test-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLab.MainForm.Test-3.2.csproj	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLab.MainForm.Test-3.2.csproj	(revision 2268)
@@ -87,4 +87,5 @@
     <Compile Include="ButtonItems\SaveToolStripButtonItem.cs" />
     <Compile Include="ButtonItems\OpenToolStripButtonItem.cs" />
+    <Compile Include="HeuristicLabSingleDocumentMainFormTestApplication.cs" />
     <Compile Include="HeuristicLabMultipleDocumentMainFormTestApplication.cs" />
     <Compile Include="EditorView.cs">
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/HeuristicLabSingleDocumentMainFormTestApplication.cs	(revision 2268)
@@ -0,0 +1,38 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.MainForm.Test {
+  [ClassInfo(Name = "SingleDocumentMainForm Test", Description="Test application for new mainform development.")]
+  public class HeuristicLabSingleDocumentMainFormTestApplication : ApplicationBase {
+    public override void Run() {
+      SingleDocumentMainForm mainForm = new SingleDocumentMainForm(typeof(ITestUserInterfaceItemProvider));
+      mainForm.Title = "Test new MAINFORM concept";
+      Application.Run(mainForm);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.Designer.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.Designer.cs	(revision 2268)
@@ -24,9 +24,93 @@
     /// </summary>
     private void InitializeComponent() {
-      this.components = new System.ComponentModel.Container();
+      WeifenLuo.WinFormsUI.Docking.DockPanelSkin dockPanelSkin1 = new WeifenLuo.WinFormsUI.Docking.DockPanelSkin();
+      WeifenLuo.WinFormsUI.Docking.AutoHideStripSkin autoHideStripSkin1 = new WeifenLuo.WinFormsUI.Docking.AutoHideStripSkin();
+      WeifenLuo.WinFormsUI.Docking.DockPanelGradient dockPanelGradient1 = new WeifenLuo.WinFormsUI.Docking.DockPanelGradient();
+      WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient1 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      WeifenLuo.WinFormsUI.Docking.DockPaneStripSkin dockPaneStripSkin1 = new WeifenLuo.WinFormsUI.Docking.DockPaneStripSkin();
+      WeifenLuo.WinFormsUI.Docking.DockPaneStripGradient dockPaneStripGradient1 = new WeifenLuo.WinFormsUI.Docking.DockPaneStripGradient();
+      WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient2 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      WeifenLuo.WinFormsUI.Docking.DockPanelGradient dockPanelGradient2 = new WeifenLuo.WinFormsUI.Docking.DockPanelGradient();
+      WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient3 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      WeifenLuo.WinFormsUI.Docking.DockPaneStripToolWindowGradient dockPaneStripToolWindowGradient1 = new WeifenLuo.WinFormsUI.Docking.DockPaneStripToolWindowGradient();
+      WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient4 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient5 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      WeifenLuo.WinFormsUI.Docking.DockPanelGradient dockPanelGradient3 = new WeifenLuo.WinFormsUI.Docking.DockPanelGradient();
+      WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient6 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient7 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      this.dockPanel = new WeifenLuo.WinFormsUI.Docking.DockPanel();
+      this.SuspendLayout();
+      // 
+      // dockPanel
+      // 
+      this.dockPanel.ActiveAutoHideContent = null;
+      this.dockPanel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.dockPanel.DockBackColor = System.Drawing.SystemColors.Control;
+      this.dockPanel.Location = new System.Drawing.Point(0, 49);
+      this.dockPanel.Name = "dockPanel";
+      this.dockPanel.Size = new System.Drawing.Size(624, 341);
+      dockPanelGradient1.EndColor = System.Drawing.SystemColors.ControlLight;
+      dockPanelGradient1.StartColor = System.Drawing.SystemColors.ControlLight;
+      autoHideStripSkin1.DockStripGradient = dockPanelGradient1;
+      tabGradient1.EndColor = System.Drawing.SystemColors.Control;
+      tabGradient1.StartColor = System.Drawing.SystemColors.Control;
+      tabGradient1.TextColor = System.Drawing.SystemColors.ControlDarkDark;
+      autoHideStripSkin1.TabGradient = tabGradient1;
+      dockPanelSkin1.AutoHideStripSkin = autoHideStripSkin1;
+      tabGradient2.EndColor = System.Drawing.SystemColors.ControlLightLight;
+      tabGradient2.StartColor = System.Drawing.SystemColors.ControlLightLight;
+      tabGradient2.TextColor = System.Drawing.SystemColors.ControlText;
+      dockPaneStripGradient1.ActiveTabGradient = tabGradient2;
+      dockPanelGradient2.EndColor = System.Drawing.SystemColors.Control;
+      dockPanelGradient2.StartColor = System.Drawing.SystemColors.Control;
+      dockPaneStripGradient1.DockStripGradient = dockPanelGradient2;
+      tabGradient3.EndColor = System.Drawing.SystemColors.ControlLight;
+      tabGradient3.StartColor = System.Drawing.SystemColors.ControlLight;
+      tabGradient3.TextColor = System.Drawing.SystemColors.ControlText;
+      dockPaneStripGradient1.InactiveTabGradient = tabGradient3;
+      dockPaneStripSkin1.DocumentGradient = dockPaneStripGradient1;
+      tabGradient4.EndColor = System.Drawing.SystemColors.ActiveCaption;
+      tabGradient4.LinearGradientMode = System.Drawing.Drawing2D.LinearGradientMode.Vertical;
+      tabGradient4.StartColor = System.Drawing.SystemColors.GradientActiveCaption;
+      tabGradient4.TextColor = System.Drawing.SystemColors.ActiveCaptionText;
+      dockPaneStripToolWindowGradient1.ActiveCaptionGradient = tabGradient4;
+      tabGradient5.EndColor = System.Drawing.SystemColors.Control;
+      tabGradient5.StartColor = System.Drawing.SystemColors.Control;
+      tabGradient5.TextColor = System.Drawing.SystemColors.ControlText;
+      dockPaneStripToolWindowGradient1.ActiveTabGradient = tabGradient5;
+      dockPanelGradient3.EndColor = System.Drawing.SystemColors.ControlLight;
+      dockPanelGradient3.StartColor = System.Drawing.SystemColors.ControlLight;
+      dockPaneStripToolWindowGradient1.DockStripGradient = dockPanelGradient3;
+      tabGradient6.EndColor = System.Drawing.SystemColors.GradientInactiveCaption;
+      tabGradient6.LinearGradientMode = System.Drawing.Drawing2D.LinearGradientMode.Vertical;
+      tabGradient6.StartColor = System.Drawing.SystemColors.GradientInactiveCaption;
+      tabGradient6.TextColor = System.Drawing.SystemColors.ControlText;
+      dockPaneStripToolWindowGradient1.InactiveCaptionGradient = tabGradient6;
+      tabGradient7.EndColor = System.Drawing.Color.Transparent;
+      tabGradient7.StartColor = System.Drawing.Color.Transparent;
+      tabGradient7.TextColor = System.Drawing.SystemColors.ControlDarkDark;
+      dockPaneStripToolWindowGradient1.InactiveTabGradient = tabGradient7;
+      dockPaneStripSkin1.ToolWindowGradient = dockPaneStripToolWindowGradient1;
+      dockPanelSkin1.DockPaneStripSkin = dockPaneStripSkin1;
+      this.dockPanel.Skin = dockPanelSkin1;
+      this.dockPanel.TabIndex = 3;
+      // 
+      // DockingMainForm
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.ClientSize = new System.Drawing.Size(624, 412);
+      this.Controls.Add(this.dockPanel);
+      this.IsMdiContainer = true;
+      this.Name = "DockingMainForm";
+      this.Controls.SetChildIndex(this.dockPanel, 0);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
     }
 
     #endregion
+
+    private WeifenLuo.WinFormsUI.Docking.DockPanel dockPanel;
   }
 }
Index: trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.cs	(revision 2268)
@@ -32,17 +32,15 @@
 namespace HeuristicLab.MainForm {
   public partial class DockingMainForm : MainFormBase {
+    public DockingMainForm()
+      : base() {
+      InitializeComponent();
+    }
+
     public DockingMainForm(Type userInterfaceItemType)
       : base(userInterfaceItemType) {
       InitializeComponent();
-      dockPanel = new DockPanel();
-      InitializeDockPanel();
-      this.IsMdiContainer = true;
-      this.Controls.Add(dockPanel);
-      this.Controls.SetChildIndex(dockPanel, 0);
     }
 
-    private DockPanel dockPanel;
-
-    public override void ShowView(IView view) {      
+    public override void ShowView(IView view) {
       if (InvokeRequired) Invoke((Action<IView>)ShowView, view);
       else {
@@ -74,78 +72,4 @@
       base.StatusStripText = ((DockForm)sender).View.Caption;
     }
-
-    private void InitializeDockPanel() {
-      DockPanelSkin dockPanelSkin1 = new DockPanelSkin();
-      AutoHideStripSkin autoHideStripSkin1 = new AutoHideStripSkin();
-      DockPanelGradient dockPanelGradient1 = new DockPanelGradient();
-      TabGradient tabGradient1 = new TabGradient();
-      DockPaneStripSkin dockPaneStripSkin1 = new DockPaneStripSkin();
-      DockPaneStripGradient dockPaneStripGradient1 = new DockPaneStripGradient();
-      TabGradient tabGradient2 = new TabGradient();
-      DockPanelGradient dockPanelGradient2 = new DockPanelGradient();
-      TabGradient tabGradient3 = new TabGradient();
-      DockPaneStripToolWindowGradient dockPaneStripToolWindowGradient1 = new DockPaneStripToolWindowGradient();
-      TabGradient tabGradient4 = new TabGradient();
-      TabGradient tabGradient5 = new TabGradient();
-      DockPanelGradient dockPanelGradient3 = new DockPanelGradient();
-      TabGradient tabGradient6 = new TabGradient();
-      TabGradient tabGradient7 = new TabGradient();
-
-      this.dockPanel.ActiveAutoHideContent = null;
-      this.dockPanel.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.dockPanel.DockBackColor = SystemColors.Control;
-      this.dockPanel.DockBottomPortion = 0.33;
-      this.dockPanel.DockLeftPortion = 0.33;
-      this.dockPanel.DockRightPortion = 0.33;
-      this.dockPanel.DockTopPortion = 0.33;
-      this.dockPanel.Location = new Point(0, 49);
-      this.dockPanel.Name = "dockPanel";
-      this.dockPanel.RightToLeftLayout = true;
-      dockPanelGradient1.EndColor = SystemColors.ControlLight;
-      dockPanelGradient1.StartColor = SystemColors.ControlLight;
-      autoHideStripSkin1.DockStripGradient = dockPanelGradient1;
-      tabGradient1.EndColor = SystemColors.Control;
-      tabGradient1.StartColor = SystemColors.Control;
-      tabGradient1.TextColor = SystemColors.ControlDarkDark;
-      autoHideStripSkin1.TabGradient = tabGradient1;
-      dockPanelSkin1.AutoHideStripSkin = autoHideStripSkin1;
-      tabGradient2.EndColor = SystemColors.ControlLightLight;
-      tabGradient2.StartColor = SystemColors.ControlLightLight;
-      tabGradient2.TextColor = SystemColors.ControlText;
-      dockPaneStripGradient1.ActiveTabGradient = tabGradient2;
-      dockPanelGradient2.EndColor = SystemColors.Control;
-      dockPanelGradient2.StartColor = SystemColors.Control;
-      dockPaneStripGradient1.DockStripGradient = dockPanelGradient2;
-      tabGradient3.EndColor = SystemColors.ControlLight;
-      tabGradient3.StartColor = SystemColors.ControlLight;
-      tabGradient3.TextColor = SystemColors.ControlText;
-      dockPaneStripGradient1.InactiveTabGradient = tabGradient3;
-      dockPaneStripSkin1.DocumentGradient = dockPaneStripGradient1;
-      tabGradient4.EndColor = SystemColors.ActiveCaption;
-      tabGradient4.LinearGradientMode = System.Drawing.Drawing2D.LinearGradientMode.Vertical;
-      tabGradient4.StartColor = SystemColors.GradientActiveCaption;
-      tabGradient4.TextColor = SystemColors.ActiveCaptionText;
-      dockPaneStripToolWindowGradient1.ActiveCaptionGradient = tabGradient4;
-      tabGradient5.EndColor = SystemColors.Control;
-      tabGradient5.StartColor = SystemColors.Control;
-      tabGradient5.TextColor = SystemColors.ControlText;
-      dockPaneStripToolWindowGradient1.ActiveTabGradient = tabGradient5;
-      dockPanelGradient3.EndColor = SystemColors.ControlLight;
-      dockPanelGradient3.StartColor = SystemColors.ControlLight;
-      dockPaneStripToolWindowGradient1.DockStripGradient = dockPanelGradient3;
-      tabGradient6.EndColor = SystemColors.GradientInactiveCaption;
-      tabGradient6.LinearGradientMode = System.Drawing.Drawing2D.LinearGradientMode.Vertical;
-      tabGradient6.StartColor = SystemColors.GradientInactiveCaption;
-      tabGradient6.TextColor = SystemColors.ControlText;
-      dockPaneStripToolWindowGradient1.InactiveCaptionGradient = tabGradient6;
-      tabGradient7.EndColor = Color.Transparent;
-      tabGradient7.StartColor = Color.Transparent;
-      tabGradient7.TextColor = SystemColors.ControlDarkDark;
-      dockPaneStripToolWindowGradient1.InactiveTabGradient = tabGradient7;
-      dockPaneStripSkin1.ToolWindowGradient = dockPaneStripToolWindowGradient1;
-      dockPanelSkin1.DockPaneStripSkin = dockPaneStripSkin1;
-      this.dockPanel.Skin = dockPanelSkin1;
-      this.dockPanel.TabIndex = 2;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.resx
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.resx	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.resx	(revision 2268)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj	(revision 2268)
@@ -82,4 +82,10 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="SingleDocumentMainForm.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="SingleDocumentMainForm.Designer.cs">
+      <DependentUpon>SingleDocumentMainForm.cs</DependentUpon>
+    </Compile>
     <Compile Include="Interfaces\IUserInterfaceItem.cs" />
     <Compile Include="MultipleDocumentMainForm.cs">
@@ -147,4 +153,10 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="SingleDocumentMainForm.resx">
+      <DependentUpon>SingleDocumentMainForm.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="DockingMainForm.resx">
+      <DependentUpon>DockingMainForm.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="MainFormBase.resx">
       <DependentUpon>MainFormBase.cs</DependentUpon>
Index: trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.Designer.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.Designer.cs	(revision 2268)
@@ -80,8 +80,8 @@
     #endregion
 
-    private System.Windows.Forms.MenuStrip menuStrip;
     private System.Windows.Forms.ToolStrip toolStrip;
     private System.Windows.Forms.StatusStrip statusStrip;
     private System.Windows.Forms.ToolStripStatusLabel statusStripLabel;
+    protected System.Windows.Forms.MenuStrip menuStrip;
   }
 }
Index: trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs	(revision 2268)
@@ -32,10 +32,14 @@
 
 namespace HeuristicLab.MainForm {
-  public abstract partial class MainFormBase : Form, IMainForm {
-    protected MainFormBase(Type userInterfaceItemType)
+  public partial class MainFormBase : Form, IMainForm {
+    protected MainFormBase()
       : base() {
       InitializeComponent();
       views = new List<IView>();
       viewChangeToolStripItems = new List<IToolStripItem>();
+    }
+
+    protected MainFormBase(Type userInterfaceItemType)
+      : this() {
       this.userInterfaceItemType = userInterfaceItemType;
       CreateGUI();
@@ -59,5 +63,5 @@
       set {
         if (InvokeRequired) {
-          Action<string> action = delegate(string s) { this.statusStripLabel.Text = s; };
+          Action<string> action = delegate(string s) { this.StatusStripText = s; };
           Invoke(action, new object[] { value });
         } else
@@ -107,5 +111,5 @@
 
     #region create menu and toolbar
-    private void CreateGUI() {
+    protected virtual void CreateGUI() {
       DiscoveryService ds = new DiscoveryService();
 
@@ -152,5 +156,8 @@
     }
 
-    private ToolStripDropDownItem FindParent(IToolStripItem item, ToolStripItemCollection parentItems) {
+    private ToolStripDropDownItem FindParent(IToolStripItem item, ToolStripItemCollection parentItems) {      
+      if (String.IsNullOrEmpty(item.Structure))
+        return null;
+
       ToolStripDropDownItem parent = null;
       foreach (string structure in item.Structure.Split(item.StructureSeparator)) {
@@ -158,5 +165,6 @@
           parent = (ToolStripDropDownItem)parentItems[structure];
         else
-          break;
+          throw new ArgumentException("Structure string for item " + item.Name +
+            " is invalid. Could not find " + structure + " in toolstrip!");
         parentItems = parent.DropDownItems;
       }
Index: trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentForm.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentForm.Designer.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentForm.Designer.cs	(revision 2268)
@@ -21,5 +21,5 @@
 
 namespace HeuristicLab.MainForm {
-  partial class MultipleDocumentForm {
+  partial class DocumentForm {
     /// <summary>
     /// Required designer variable.
@@ -47,5 +47,5 @@
     /// </summary>
     private void InitializeComponent() {
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MultipleDocumentForm));
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DocumentForm));
       this.viewPanel = new System.Windows.Forms.Panel();
       this.SuspendLayout();
Index: trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentForm.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentForm.cs	(revision 2268)
@@ -29,5 +29,5 @@
 
 namespace HeuristicLab.MainForm {
-  public partial class MultipleDocumentForm : Form {
+  public partial class DocumentForm : Form {
     private IView myView;
     public IView View {
@@ -35,8 +35,8 @@
     }
 
-    public MultipleDocumentForm() {
+    public DocumentForm() {
       InitializeComponent();
     }
-    public MultipleDocumentForm(IView view)
+    public DocumentForm(IView view)
       : this() {
       myView = view;
Index: trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.Designer.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.Designer.cs	(revision 2268)
@@ -31,7 +31,10 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.ClientSize = new System.Drawing.Size(284, 264);
+      this.ClientSize = new System.Drawing.Size(596, 407);
+      this.IsMdiContainer = true;
       this.Name = "MultipleDocumentMainForm";
       this.ResumeLayout(false);
+      this.PerformLayout();
+
     }
 
Index: trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.cs	(revision 2267)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.cs	(revision 2268)
@@ -31,8 +31,19 @@
 namespace HeuristicLab.MainForm {
   public partial class MultipleDocumentMainForm : MainFormBase {
+    public MultipleDocumentMainForm()
+      : base() {
+      InitializeComponent();
+    }
+
     public MultipleDocumentMainForm(Type userInterfaceType)
       : base(userInterfaceType) {
       InitializeComponent();
-      this.IsMdiContainer = true;
+    }
+
+    protected override void CreateGUI() {
+      base.CreateGUI();
+      ToolStripMenuItem window = new ToolStripMenuItem("Windows");
+      base.menuStrip.MdiWindowListItem = window;
+      base.menuStrip.Items.Add(window);
     }
 
@@ -41,5 +52,5 @@
       else {
         base.ShowView(view);
-        MultipleDocumentForm form = new MultipleDocumentForm(view);
+        DocumentForm form = new DocumentForm(view);
         form.Activated += new EventHandler(MultipleDocumentFormActivated);
         form.FormClosing += new FormClosingEventHandler(view.FormClosing);
@@ -53,10 +64,10 @@
 
     private void MultipleDocumentFormActivated(object sender, EventArgs e) {
-      base.ActiveView = ((MultipleDocumentForm)sender).View;
-      base.StatusStripText = ((MultipleDocumentForm)sender).View.Caption;
+      base.ActiveView = ((DocumentForm)sender).View;
+      base.StatusStripText = ((DocumentForm)sender).View.Caption;
     }
 
     private void MultipleDocumentFormClosed(object sender, FormClosedEventArgs e) {
-      MultipleDocumentForm form = (MultipleDocumentForm)sender;
+      DocumentForm form = (DocumentForm)sender;
       views.Remove(form.View);
       if (views.Count == 0)
Index: trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.Designer.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.Designer.cs	(revision 2268)
@@ -0,0 +1,42 @@
+﻿namespace HeuristicLab.MainForm {
+  partial class SingleDocumentMainForm {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.SuspendLayout();
+      // 
+      // SingleDocumentMainForm
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.ClientSize = new System.Drawing.Size(624, 412);
+      this.Name = "SingleDocumentMainForm";
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+  }
+}
Index: trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.cs	(revision 2268)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using WeifenLuo.WinFormsUI.Docking;
+
+namespace HeuristicLab.MainForm {
+  public partial class SingleDocumentMainForm : MainFormBase {
+    public SingleDocumentMainForm()
+      : base() {
+      InitializeComponent();
+    }
+
+    public SingleDocumentMainForm(Type userInterfaceItemType)
+      : base(userInterfaceItemType) {
+      InitializeComponent();
+    }
+
+    public override void ShowView(IView view) {
+      if (InvokeRequired) Invoke((Action<IView>)ShowView, view);
+      else {
+        base.ShowView(view);
+        DocumentForm form = new DocumentForm(view);
+        form.Activated += new EventHandler(DockFormActivated);
+        form.FormClosing += new FormClosingEventHandler(view.FormClosing);
+        form.FormClosed += new FormClosedEventHandler(DockFormClosed);
+        foreach (IToolStripItem item in ViewChangedToolStripItems)
+          view.StateChanged += new EventHandler(item.ViewChanged);
+        form.Show(this);
+      }
+    }
+
+    private void DockFormClosed(object sender, FormClosedEventArgs e) {
+      DocumentForm form = (DocumentForm)sender;
+      views.Remove(form.View);
+      if (views.Count == 0)
+        ActiveView = null;
+      form.Activated -= new EventHandler(DockFormActivated);
+      form.FormClosing -= new FormClosingEventHandler(form.View.FormClosing);
+      form.FormClosed -= new FormClosedEventHandler(DockFormClosed);
+      foreach (IToolStripItem item in ViewChangedToolStripItems)
+        form.View.StateChanged -= new EventHandler(item.ViewChanged);
+    }
+
+    private void DockFormActivated(object sender, EventArgs e) {
+      base.ActiveView = ((DocumentForm)sender).View;
+      base.StatusStripText = ((DocumentForm)sender).View.Caption;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.resx
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.resx	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.resx	(revision 2268)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
